(deftemplate klijenti
  (slot ime (type STRING))
  (slot proslava (allowed-symbols zurka rodjendan svadba))
  (slot broj_gostiju(type INTEGER))
)

(deftemplate agencija
  (multislot naziv (type SYMBOL))
  (slot cert (type FLOAT))
)

(defrule p1
=>
(printout t "Vase ime: ")
(bind ?ime (read))
(printout t "Vrsta proslave: ")
(bind ?vr (read))
(printout t "Broj gostiju: ")
(bind ?br (read))
(assert (klijenti (ime ?ime)(proslava ?vr)(broj_gostiju ?br)))
)

(defrule p2
(klijenti (proslava rodjendan)(broj_gostiju ?br))
(test (> ?br 50))
=>
(assert (agencija (naziv Mama Zaga)(cert 1.0))))

(defrule p3
(klijenti (proslava zurka|rodjendan))
=>
(assert (agencija (naziv Djusepe)(cert 0.7)))
(assert (agencija (naziv Trojka)(cert 0.7))))

(defrule p4
(klijenti (proslava rodjendan))
?a1 <- (agencija (naziv Mama Zaga))
?a2 <- (agencija (naziv Trojka))
=>
(printout t "Da li vecinu gostiju cine odrasli ili deca? ")
(bind ?g (read))
(if (eq ?g odrasli) then
   (modify ?a1 (cert 0.8))
   (retract ?a2))
(if (eq ?g deca) then
   (modify ?a2 (cert 0.8))
   (retract ?a1)))

(defrule p5
(agencija (naziv ?n1)(cert ?c1))
(agencija (naziv ?n2&~?n1)(cert ?c2))
=>
(if (> ?c1 ?c2) then
(printout t "Najbolji izbor za vas je agencija: " ?n1 crlf)
else 
(printout t "Najbolji izbor za vas je agencija: " ?n2 crlf)))